// Copyright (c) 2015, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

/// Patterns for developing Omnibus applications
library omnibus.patterns;

import 'dart:async';

import 'package:omnibus/omnibus.dart';
import 'package:http/http.dart' as http;

/// Module bootstrap function
typedef Future ModuleMain(Omnibus bus, http.Client httpClient);

/// Extension of [StateData] with no contents at all.
class EmptyState extends StateData {}

/// Extension of [StateData] that adds the parent bus.
class BusState extends StateData {
  /// Parent bus
  Omnibus bus;

  /// Constuctor
  BusState(this.bus);
}

/// Extension of [BusState] that adds a shared HTTP client.
class SimpleState extends BusState {
  /// Shared HTTP client
  http.Client httpClient;

  /// Constuctor
  SimpleState(Omnibus bus, this.httpClient) : super(bus);
}
